/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Criacao;
import com.tabajara.base.tables.records.CriacaoRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.sql.Date;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CriacaoDao extends AbstractVertxDAO<CriacaoRecord, com.tabajara.base.tables.pojos.Criacao, Integer, Future<List<com.tabajara.base.tables.pojos.Criacao>>, Future<com.tabajara.base.tables.pojos.Criacao>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<CriacaoRecord,com.tabajara.base.tables.pojos.Criacao,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public CriacaoDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Criacao.CRIACAO, com.tabajara.base.tables.pojos.Criacao.class, new JDBCClassicQueryExecutor<CriacaoRecord,com.tabajara.base.tables.pojos.Criacao,Integer>(com.tabajara.base.tables.pojos.Criacao.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Criacao object) {
        return object.getCriaid();
    }

    /**
     * Find records that have <code>criaespecie IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Criacao>> findManyByCriaespecie(List<String> values) {
        return findManyByCondition(Criacao.CRIACAO.CRIAESPECIE.in(values));
    }

    /**
     * Find records that have <code>criadata IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Criacao>> findManyByCriadata(List<Date> values) {
        return findManyByCondition(Criacao.CRIACAO.CRIADATA.in(values));
    }
}
